#!/usr/bin/perl
###############################################################################
#                                                                             #
# converter.pl                                                                #
# Krzysztof Wozniak                                                           #
#                                                                             #
###############################################################################

# --- separator w plikach .txt ------------------------------------------------
# --- spacja ---
$sep = ' ';
# --- tabulacja ---
# $sep = "\t";
# -----------------------------------------------------------------------------

if (scalar(@ARGV) != 2) {
  print "\n Syntax: converter.pl plik_z_pomiarami nazwa_wyniku \n";
  exit;
}
$mesFile = $ARGV[0];
$newFile1 = $ARGV[1].'_ch1time.txt';
$newFile2 = $ARGV[1].'_ch2sort.txt';

$openVal = open BASEFILE, "$mesFile";
if ($openVal != 1) {
  print "\nPlik $mesFile nie istnieje!\n";
  exit;
}
@fileTab = <BASEFILE>;
close BASEFILE;

$start = 0;
$openVal = open FILE1, ">$newFile1";
$openVal = open FILE2, ">$newFile2";

# --- odkomentowac jesli pierwsze linie w plikach maja byc '0 0'-----------
# $firstLine = "0".$sep."0\n";
# print FILE1 $firstLine;
# print FILE2 $firstLine;
# -------------------------------------------------------------------------

$time = 0;

foreach $line (@fileTab) {
  if ($line =~ /INTERVAL/) {
    FormatLine($line);     
    ($a1,$a2,$int,$a3) = split(/\^/,$line);    
  }
  if (($line =~ /^[0-9]/) && ($start == 0)) {
    $start = 1;
  } 
  if ($start == 1) {
    FormatLine($line);
# --- odkomentowac ponizsza linie w celu zamiany kropek na przecinki -------
#    $line =~ s/\./\,/g;
# --------------------------------------------------------------------------
    if ($line =~ /^[0-9]/) {
      $time = $time + $int;
    } else { 
      ($a1,$chan1,$a2,$a3,$chan2,$a4) = split(/\^/,$line);
      $first = $time.$sep.$chan1;
      print FILE1 "$first\n";
# --- ustalenie kanalu po ktorym nastepuje sortowanie ----------------------
# --- sortowanie po 1 kanale ---
#      $chans{$chan1} = $chan2;
# --- sortowanie po 2 kanale ---
      $chans{$chan2} = $chan1;
# --------------------------------------------------------------------------
    }
  }
}

close FILE1;

@aftSort = sort { $a <=> $b } (keys %chans);
foreach $key (@aftSort) {
  $second = $key.$sep.$chans{$key};
  print FILE2 "$second\n";
}
close FILE2;

exit;

# =============================================================================

sub FormatLine {
  foreach $str (@_) {
    $str =~ s/[\ \n\r\t]+$//g;
    $str =~ s/^[\ \n\r\t\0]+//g;
    $str =~ s/[\ \n\r\t\0\=]+/\^/g;
  }
}
