unit app2_service_config;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  Tapp2_service = class(TForm)
    GroupBox1: TGroupBox;
    OpenDialog1: TOpenDialog;
    tabele: TListBox;
    Panel2: TPanel;
    GroupBox2: TGroupBox;
    port: TEdit;
    Label2: TLabel;
    wyswietlanie_zapytan: TCheckBox;
    logowanie_zapytan: TCheckBox;
    plik_log: TEdit;
    Button1: TButton;
    Button5: TButton;
    Panel1: TPanel;
    Button6: TButton;
    Panel3: TPanel;
    Button4: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure logowanie_zapytanClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function ConfigGetValue(const option: PChar): PChar; external 'regopts.dll' name 'ConfigGetValue';
function ConfigSetValue(const option, value: PChar): PChar; external 'regopts.dll' name 'ConfigSetValue';

const
  CFG_PORT        = 'port';
  CFG_TABLEDIR    = 'tables';
  CFG_ECHOQUERIES = 'echo_queries';
  CFG_LOGQUERIES  = 'log_queries';

var
  app2_service   :Tapp2_service;

implementation

{$R *.dfm}

procedure Tapp2_service.FormCreate(Sender: TObject);
var buf:string;
begin
port.Text:=ConfigGetValue(CFG_PORT);
buf:=ConfigGetValue(CFG_TABLEDIR);
while (pos(',', buf)>0) and (length(buf)>1) do
    begin
    tabele.Items.Add(copy(buf, 0, pos(',', buf)-1));
    buf :=copy(buf, pos(',', buf)+1, Length(buf));
    end;

if ConfigGetValue(CFG_ECHOQUERIES)='0' then
  wyswietlanie_zapytan.Checked:=false
else
  wyswietlanie_zapytan.Checked:=true;
if ConfigGetValue(CFG_LOGQUERIES)='0' then
  logowanie_zapytan.Checked:=false
else
  begin
  logowanie_zapytan.Checked:=true;
  plik_log.Text:=ConfigGetValue(CFG_LOGQUERIES);
  end;
logowanie_zapytanClick(Sender);
end;

procedure Tapp2_service.Button3Click(Sender: TObject);
var buf :string;
    i   :integer;
begin
buf:=port.Text;
ConfigSetValue(CFG_PORT, PChar(buf));
buf:='';
for i:=0 to tabele.Items.Count-1 do
  buf:=buf+tabele.Items[i]+',';
ConfigSetValue(CFG_TABLEDIR,PChar(buf));
if wyswietlanie_zapytan.Checked then
  buf:='1'
else
  buf:='0';
ConfigSetValue(CFG_ECHOQUERIES, PChar(buf));
if (logowanie_zapytan.Checked) and (plik_log.Text<>'') then
  buf:=plik_log.Text
else
  buf:='0';
ConfigSetValue(CFG_LOGQUERIES, PChar(buf));
Application.Terminate;
end;

procedure Tapp2_service.Button4Click(Sender: TObject);
begin
Application.Terminate;
end;

procedure Tapp2_service.Button2Click(Sender: TObject);
var i:integer;
begin
{if katalog.Text='' then Button6Click(Sender)
else begin
  OpenDialog1.Title:='Wybierz pliki tabel';
  opendialog1.InitialDir:=katalog.Text;
  OpenDialog1.Options:=[ofNoChangeDir,ofPathMustExist,ofAllowMultiSelect,ofEnableSizing];
  if OpenDialog1.Execute then
    for i:=0 to High
  katalog.Text:=copy(opendialog1.FileName, 0, LastDelimiter('\', opendialog1.FileName));
end;
}end;

procedure Tapp2_service.Button1Click(Sender: TObject);
begin
//opendialog1.FileName:=plik_log.Text;
OpenDialog1.Options:=[ofPathMustExist,ofEnableSizing];
if OpenDialog1.Execute then
  plik_log.Text:=opendialog1.FileName;

end;

procedure Tapp2_service.logowanie_zapytanClick(Sender: TObject);
begin
plik_log.Enabled := logowanie_zapytan.Checked;
Button1.Enabled := logowanie_zapytan.Checked;
Button5.Enabled := logowanie_zapytan.Checked;
end;

procedure Tapp2_service.Button6Click(Sender: TObject);
begin
OpenDialog1.Title:='Wybierz pliki tabel';
//copy(opendialog1.FileName, 0, LastDelimiter('\', opendialog1.FileName));
//opendialog1.InitialDir:=katalog.Text;
OpenDialog1.Options:=[ofPathMustExist,ofAllowMultiSelect,ofEnableSizing];
if OpenDialog1.Execute then
  tabele.Items:=Opendialog1.Files;
end;

end.
