library regopts;

uses
  SysUtils,
  Classes,
  Windows,
  Registry;

// TRegistry

{$R *.res}


const CONFIG_HKEY = HKEY_LOCAL_MACHINE;
      CONFIG_PATH = '\Software\delphiapp2';
      // pelna sciezka: HKEY_LOCAL_MACHINE\Software\delphiapp2

  {**********************
    ODCZYT I ZAPIS OPCJI
  **********************}

// odczytanie wartosci danej opcji z rejestru
function ConfigGetValue(const option: PChar): PChar;
var
  reg: TRegistry;
begin
  reg := TRegistry.Create;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  try
    reg.OpenKey(CONFIG_PATH, False);
    Result := PChar(reg.ReadString(option));
    reg.CloseKey;
  finally
    reg.Free;
  end;
end;

// zapisanie wartosci danej opcji do rejestru
// zwraca zawartosc jaka jest w rejestrze (jesli udalo sie
// zapisac, bedzie ona taka sama, jak w argumencie)
function ConfigSetValue(const option, value: PChar): PChar;
var
  reg: TRegistry;
begin
  reg := TRegistry.Create;
  reg.RootKey := CONFIG_HKEY;
  try
    reg.OpenKey(CONFIG_PATH, False);
    reg.WriteString(option, value);
    Result := ConfigGetValue(option);
    reg.CloseKey;
  finally
    reg.Free;
  end;
end;

exports
  ConfigGetValue name 'ConfigGetValue',
  ConfigSetValue name 'ConfigSetValue';
begin
end.
