unit zaklad_form;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask;

type
  TZaklad = class(TForm)
    GroupBox3: TGroupBox;
    Label1: TLabel;
    kierownik: TEdit;
    Label8: TLabel;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ulica: TEdit;
    miasto: TEdit;
    kodpoczt: TMaskEdit;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    strazy: TEdit;
    kucharzy: TEdit;
    Button2: TButton;
    nazwa: TComboBox;
    button_usun: TButton;
    button_zmien: TButton;
    procedure Button2Click(Sender: TObject);
    procedure button_zmienClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure button_usunClick(Sender: TObject);
    procedure nazwaSelect(Sender: TObject);
  private
    insert :boolean;
    procedure wyczysc;
    procedure zaladuj;
  public
    idzakl :string;
  end;

var
  Zaklad: TZaklad;

implementation

uses main, mylist, myquery;

{$R *.dfm}

procedure TZaklad.wyczysc;
begin
nazwa.Text:='';
kierownik.Text:='';
ulica.Text:='';
kodpoczt.Text:='';
miasto.Text:='';
strazy.Text:='';
kucharzy.Text:='';
end;

procedure TZaklad.zaladuj;
var buf :TMyList;
    i   :integer;
begin
with form1 do
  begin
  i:= select('SELECT * FROM "zaklady" WHERE idzakl="'+idzakl+'"');
  if i>0 then
    begin
    buf := TMyList.Create;
    buf := fetchrecord;
    buf.next;
    nazwa.Text:=buf.next;
    kierownik.Text:=buf.next;
    ulica.Text:=buf.next;
    kodpoczt.Text:=buf.next;
    miasto.Text:=buf.next;
    strazy.Text:=buf.next;
    kucharzy.Text:=buf.next;
    dec(i);
    while i>0 do
      fetchrecord;
    end
  else showmessage('BRAK ZAKLADU O ID='+idzakl); // ERROR
  end;
end;


procedure TZaklad.Button2Click(Sender: TObject);
begin
zaklad.Hide;
end;

procedure TZaklad.button_zmienClick(Sender: TObject);
var query :TMyQuery;
begin
query := TMyQuery.Create;
if insert=true then
  query.operation := QINSERT
else
  query.operation := QUPDATE;
query.table:='zaklady';
query.field_add('nazwa', nazwa.Text);              // UWAGA! kolejnosc wystepowania
query.field_add('kierownik', kierownik.Text);      // field_add ma znaczenie dla
query.field_add('ulica', ulica.Text);              // zapytania SELECT, jesli tu
query.field_add('kod', kodpoczt.Text);             // zmieniasz kolejnosc, zmien tez
query.field_add('miasto', miasto.Text);            // cyfry, kilka linii nizej...
query.field_add('strazy', strazy.text);
query.field_add('kucharzy', kucharzy.Text);
query.field_add('idzakl', idzakl);
if query.operation=QUPDATE then
  query.condition_add('idzakl', idzakl);
form1.sendquery(query.sql);
zaklad.Hide;
end;

procedure TZaklad.FormShow(Sender: TObject);
var i:integer;
    buf :TMyList;
begin
nazwa.Items.Clear;
i :=form1.select('SELECT nazwa FROM "zaklady" ORDER BY nazwa');
if i>0 then
  begin
  buf := TMyList.Create;
  while i>0 do
    begin
    buf := form1.fetchrecord;
    nazwa.Items.Add(buf.current);
    dec(i);
    end;
  buf.Destroy;
  end;

button_zmien.Caption:='Zmien';
button_usun.Enabled:=true;
wyczysc;
insert:=false;
if idzakl='' then
  begin
  idzakl:=inttostr(random(MaxInt));
  insert:=true;
  button_zmien.Caption:='Dodaj';
  button_usun.Enabled:=false;
  end
else zaladuj;
end;

procedure TZaklad.button_usunClick(Sender: TObject);
begin
showmessage('Usunac zaklad karny?');
if idzakl='' then
  form1.sendquery('DELETE FROM "zaklady" WHERE idzakl="'+idzakl+'"');
end;

procedure TZaklad.nazwaSelect(Sender: TObject);
var i:integer;
    buf :TMyList;
begin
i :=form1.select('SELECT idzakl FROM "zaklady" WHERE nazwa="'+nazwa.text+'"');
if i>0 then
  begin
  buf := TMyList.Create;
  if i>0 then
    begin
    buf :=form1.fetchrecord;
    dec(i);
    idzakl:=buf.current;
    while i>0 do
      begin
      form1.fetchrecord;
      dec(i);
      end;
//    insert:=false;
    zaladuj;
    end;
  buf.Destroy;
  end;

end;

end.
