unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, Grids, Sockets, Buttons, ComCtrls, Math,

  myquery, mylist, RpRave, RpDefine, RpCon, ToolWin, StdCtrls;

const WOLNOSC_ID='0';

type
  Twiezien = record
    imie             :string;
    nazwisko         :string;
    plec             :integer;
    pesel            :string;
    imie_matki       :string;
    cechy_szczegolne :string;
    kolor_oczu       :integer;
    kolor_skory      :integer;
    karnacja         :integer;
    stan             :string;
    id               :string;
    end;

  Tzakladkarny = record
    nazwa     :string;
    kierownik :string;
    ulica     :string;
    kod_poczt :string;
    miasto    :string;
    strazy    :integer;
    kucharzy  :integer;
    idzakl    :string;
    end;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Plik1: TMenuItem;
    Opcje1: TMenuItem;
    Informacje1: TMenuItem;
    Oprogramie1: TMenuItem;
    Ustawienia1: TMenuItem;
    N1: TMenuItem;
    ematypomocy1: TMenuItem;
    Zakoncz1: TMenuItem;
    N2: TMenuItem;
    Nowy1: TMenuItem;
    kontakt1: TMenuItem;
    Polacz1: TMenuItem;
    N3: TMenuItem;
    Drukuj1: TMenuItem;
    N4: TMenuItem;
    zakladkarny1: TMenuItem;
    Panel1: TPanel;
    grid: TStringGrid;
    panel_web: TPanel;
    TcpClient1: TTcpClient;
    PopupMenu1: TPopupMenu;
    Szczegoly1: TMenuItem;
    N5: TMenuItem;
    menu_zwolnij: TMenuItem;
    Edytuj1: TMenuItem;
    menu_zamknij: TMenuItem;
    Timer1: TTimer;
    Listgonczy1: TMenuItem;
    N6: TMenuItem;
    Zakladykarne1: TMenuItem;
    N7: TMenuItem;
    Widok1: TMenuItem;
    Pasekmenu1: TMenuItem;
    Pasekstanu1: TMenuItem;
    WidoksieciWeb1: TMenuItem;
    N8: TMenuItem;
    StatusBar1: TStatusBar;
    Odswierz1: TMenuItem;
    N9: TMenuItem;
    menu_zamknij_default: TMenuItem;
    Usun1: TMenuItem;
    Sortuj1: TMenuItem;
    Wgnazwiska1: TMenuItem;
    Wgimienia1: TMenuItem;
    Wgpesel1: TMenuItem;
    Wgstanu1: TMenuItem;
    Odwrotnie1: TMenuItem;
    N10: TMenuItem;
    RvCustomConnection1: TRvCustomConnection;
    RvProject1: TRvProject;
    CoolBar1: TCoolBar;
    ControlBar1: TControlBar;
    panel_przyciski: TPanel;
    kontaktnowy: TSpeedButton;
    SpeedButton3: TSpeedButton;
    button_polacz: TSpeedButton;
    SpeedButton7: TSpeedButton;
    button_resoc: TSpeedButton;
    button_dane: TSpeedButton;
    button_zwolnij: TSpeedButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Image1: TImage;
    Image2: TImage;
    wyslano: TLabel;
    odebrano: TLabel;
    ProgressBar1: TProgressBar;
    Edycja1: TMenuItem;
    Szukaj1: TMenuItem;
    Filtruj1: TMenuItem;
    procedure Ustawienia1Click(Sender: TObject);
    procedure Polacz1Click(Sender: TObject);
    procedure Zakoncz1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Drukuj1Click(Sender: TObject);
    procedure Szczegoly1Click(Sender: TObject);
    procedure menu_zwolnijClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Oprogramie1Click(Sender: TObject);
    procedure Edytuj1Click(Sender: TObject);
    procedure zakladkarny1Click(Sender: TObject);
    procedure Zakladykarne1Click(Sender: TObject);
    procedure Pasekmenu1Click(Sender: TObject);
    procedure Pasekstanu1Click(Sender: TObject);
    procedure WidoksieciWeb1Click(Sender: TObject);
    procedure TcpClient1Connect(Sender: TObject);
    procedure TcpClient1Disconnect(Sender: TObject);
    procedure TcpClient1Receive(Sender: TObject; Buf: PAnsiChar;
      var DataLen: Integer);
    procedure TcpClient1Send(Sender: TObject; Buf: PAnsiChar;
      var DataLen: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure Odswierz1Click(Sender: TObject);
    procedure gridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure menu_zamknij_defaultClick(Sender: TObject);
    procedure kontaktnowyClick(Sender: TObject);
    procedure Usun1Click(Sender: TObject);
    procedure gridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Odwrotnie1Click(Sender: TObject);
    procedure Wgnazwiska1Click(Sender: TObject);
    procedure Wgimienia1Click(Sender: TObject);
    procedure Wgpesel1Click(Sender: TObject);
    procedure Wgstanu1Click(Sender: TObject);
    procedure Szukaj1Click(Sender: TObject);
    procedure Filtruj1Click(Sender: TObject);
  private
    menu_zakladow :TMyList;
    orderby :string;
    procedure zaladuj_wiezniowie(query :string);
    procedure zapelnij_wiersz(insert_query :string; index :integer);
    procedure aktualizuj_nazwy_wiezien;
  public
    filtr :string;
    server_echo :boolean;
    WOLNOSC_NAZWA :string; // domyslnie taka sama, jak WOLNOSC_ID, zmieniana przez nazwa_wiezienia()
    function inttobytes(i :integer) :string;
    function wiezien_form_show(var w:Twiezien; caption :string) :boolean;
    // Z bazy danych
    function sendquery(query :string) :boolean;
    function select(query :string; results_expected :integer=-1) :integer;
    function fetchrecord :TMyList;
    function nazwa_wiezienia(id :string) :string;
    procedure wiezien(var w :Twiezien; typ: TQueryOperationType);
    procedure zmienzaklad(id :string; nowystan :string);
    function SQL_WSZYSCY_WIEZNIOWIE :string;
  end;

resourcestring
  SQL_NAZWY_WIEZIEN='SELECT nazwa, idzakl FROM "zaklady" ORDER BY nazwa';

var
  Form1: TForm1;

implementation

uses ustawienia_form, kontakt_form, zaklad_form, about_form,
  przebiegresoc_fom, znajdz_form;

{$R *.dfm}

function TForm1.SQL_WSZYSCY_WIEZNIOWIE:string;
begin
Result :='SELECT nazwisko, imie, pesel, stan, id FROM "wiezniowie"';
if filtr<>'' then Result:=Result+' WHERE '+filtr;
Result :=Result+' ORDER BY '+orderby;
if Odwrotnie1.Checked then Result := Result+' DESC';
end;

function TForm1.nazwa_wiezienia(id :string) :string;
var tmp :TMyList;
begin
tmp := TMyList.Create;
if select('SELECT nazwa FROM "zaklady" WHERE idzakl="'+id+'"')=1 then
  begin
  tmp := fetchrecord;
  Result:=tmp.current;
  if id=WOLNOSC_ID then WOLNOSC_NAZWA:=tmp.current;
  end
else
  Result:=id;
tmp.Destroy;
end;

function TForm1.select(query :string; results_expected :integer=-1) :integer;
var r :integer;
begin
r:=0;
if sendquery(query) then
  try
    r:=strtoint(tcpclient1.Receiveln);
  except
    on EConvertError do
      showmessage('SELECT Oczekiwano liczby linii'); //ERROR
  end;
  if (results_expected<>-1) and (results_expected<>r) then
     showmessage('Liczba odpowiedzi inna niz oczekiwana'); // ERROR;
Result:= r;
end;

function TForm1.sendquery(query :string) :boolean;
var buf :string;
begin
Result:=false;
if tcpclient1.Connected then
  begin
  tcpclient1.sendln(query);
  if server_echo then
    begin
    buf :=tcpclient1.receiveln;
    if pos('ERROR', buf)=1 then
      showmessage('Dostalismy ERRORA! '+buf) // ERROR
    else
      result :=true;
    end;
  buf :=tcpclient1.receiveln;
  if pos('ERROR', buf)=1 then
    showmessage('Dostalismy ERRORA! '+buf) // ERROR
  else
    result :=true;
  end
else
  showmessage('Brak polaczenia!') // ERROR
end;

function TForm1.fetchrecord :TMyList;
var tmp :TMyList;
    tmpquery :TMyQuery;
    buf :string;
    i :integer;
begin
tmp:=nil;
if tcpclient1.Connected then
  begin
  tmp := TMyList.Create;
  tmpquery := TMyQuery.Create;
  buf :=tcpclient1.Receiveln;
  tmpquery.sql := buf;
  for i:=0 to High(tmpquery.fields) do
    tmp.insert(tmpquery.fields[i].value);
  tmpquery.Destroy;
  end;
result :=tmp;
end;

procedure TForm1.zaladuj_wiezniowie(query :string);
var i :integer;
    num :integer;
    tmpquery :TMyQuery;
begin
tmpquery := TMyQuery.Create;
grid.RowCount :=2;
num :=select(query);
statusbar1.Panels[1].Text:=inttostr(num)+' osob';
progressbar1.Position:=0;
progressbar1.Max:=num;
progressbar1.Visible:=true;
progressbar1.Step:=1;
for i:=0 to num-1 do
    begin
    tmpquery.sql:=tcpclient1.Receiveln;
    with grid do
      begin
      if i>=RowCount then
        RowCount := RowCount+1;
      Cells[0, i+1]:= tmpquery.fields[0].value;
      Cells[1, i+1]:= tmpquery.fields[1].value;
      Cells[2, i+1]:= tmpquery.fields[2].value;
      Cells[3, i+1]:= tmpquery.fields[3].value; // numer wiezienia w kolumnie Stan
      Cells[5, i+1]:= Cells[3, i+1];            // oraz w kolumnie IDZAKL
      Cells[4, i+1]:= tmpquery.fields[4].value;
      Repaint;
      end;
    progressbar1.StepIt;
    end;
progressbar1.Visible:=false;
tmpquery.Destroy;
end;

procedure TForm1.zapelnij_wiersz(insert_query :string; index :integer);
begin
end;

procedure TForm1.aktualizuj_nazwy_wiezien;
var i:integer;
    tmp :TMyList;
    tmpmenu :TMenuItem;
    buf :Variant;
begin
for i:=1 to grid.rowcount-1 do
  grid.Cells[3, i] := nazwa_wiezienia(grid.Cells[5, i]);
while menu_zamknij.Count>1 do
  begin
  menu_zakladow.delete;
  menu_zamknij.Delete(1);
  end;
i :=select(SQL_NAZWY_WIEZIEN);
tmp :=TMyList.Create;
buf :=VarArrayCreate([0,2], varOleStr);
while i>0 do
  begin
  tmp := fetchrecord;
  if tmp.current<>WOLNOSC_ID then
    begin
    tmpmenu := TMenuItem.Create(Self);
    tmpmenu.Caption := tmp.next;
    tmpmenu.OnClick := menu_zamknij_defaultClick;
    menu_zamknij.Add(tmpmenu);
    buf[0] :=tmp.Current;
    buf[1] :=tmp.Next;
    menu_zakladow.insert(buf);
    end;
  dec(i);
  end;
tmp.Destroy;
end;

procedure TForm1.Ustawienia1Click(Sender: TObject);
begin
ustawienia.show;
end;

procedure TForm1.Polacz1Click(Sender: TObject);
begin
if tcpclient1.Connected then
  tcpclient1.Disconnect
else
  begin
  tcpclient1.Connect;
  Odswierz1Click(sender);
  end;
end;

procedure TForm1.Zakoncz1Click(Sender: TObject);
begin
application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
odebrano.caption:='';
wyslano.caption:='';
filtr:='';
orderby :='nazwisko';
grid.Cells[0, 0] :='Nazwisko';
grid.Cells[1, 0] :='Imie';
grid.Cells[2, 0] :='Pesel';
grid.Cells[3, 0] :='Stan';
grid.Cells[4, 0] :='ID';
grid.Cells[5, 0] :='IDZAKL';
grid.ColWidths[4]:=-1; // ukrywamy dane istotne dla programu,
grid.ColWidths[5]:=-1; // a malo mowiace uzytkownikowi
WOLNOSC_NAZWA:=WOLNOSC_ID;
menu_zakladow := TMyList.Create;
randomize;
end;

procedure TForm1.Drukuj1Click(Sender: TObject);
begin
rvproject1.Execute;
// drukowanie
end;

procedure TForm1.Szczegoly1Click(Sender: TObject);
begin
if grid.PopupMenu.AutoPopup then
  przebieg_resoc.show;
end;

procedure TForm1.menu_zwolnijClick(Sender: TObject);
begin
showmessage('Napewno zwolnic tego wieznia?'); // AREYOUSURE ERROR
with grid do
  zmienzaklad(cells[4, Selection.Top], WOLNOSC_ID);
odswierz1click(sender);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
AboutBox.OKButton.Click;
AboutBox.OKButton.Visible:=true;
Timer1.Enabled:=false;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
timer1.Interval:=500;
AboutBox.OKButton.Visible:=false;
AboutBox.ShowModal;
end;

procedure TForm1.Oprogramie1Click(Sender: TObject);
begin
AboutBox.Show;
end;

procedure TForm1.zakladkarny1Click(Sender: TObject);
begin
zaklad.idzakl:='';
zaklad.show;
end;

procedure TForm1.Zakladykarne1Click(Sender: TObject);
begin
if (grid.Selection.Top in [1..grid.rowcount-1]) and (grid.Cells[5, grid.Selection.Top]<>'') then
  zaklad.idzakl:=grid.Cells[5, grid.Selection.Top]
else zaklad.idzakl:=WOLNOSC_ID;
zaklad.Show;
end;

procedure TForm1.Pasekmenu1Click(Sender: TObject);
begin
Pasekmenu1.Checked := not Pasekmenu1.Checked;
panel_przyciski.Visible := Pasekmenu1.Checked;
end;

procedure TForm1.Pasekstanu1Click(Sender: TObject);
begin
Pasekstanu1.Checked := not Pasekstanu1.Checked;
StatusBar1.Visible := Pasekstanu1.Checked;
end;

procedure TForm1.WidoksieciWeb1Click(Sender: TObject);
begin
WidoksieciWeb1.Checked := not WidoksieciWeb1.Checked;
panel_web.Visible := WidoksieciWeb1.Checked;
end;

procedure TForm1.TcpClient1Connect(Sender: TObject);
var buf :string;
    i   :integer;
begin
Polacz1.Caption:='Pracuj w trybie off-line';
StatusBar1.Panels[0].Text:='on-line';
tcpclient1.Receiveln; // odczytaj przywitanie
tcpclient1.Sendln('VERSION');
buf :=tcpclient1.Receiveln;
with ustawienia do
  begin
  wersja.Caption:=buf;
  if buf<>'Ver.1' then
    begin
    showmessage('NIEZNANA WERSJA BAZY DANYCH:'+buf);//ERROR
    tcpclient1.Disconnect;
    end;
  tcpclient1.Sendln('UPTIME');
  uptime.Caption := tcpclient1.Receiveln;
  tcpclient1.Sendln('ECHO');
  echo.Caption := tcpclient1.Receiveln;
  if echo.Caption='YES' then server_echo := true
    else server_echo := false;
  tcpclient1.Sendln('TABLES');
  buf :=tcpclient1.Receiveln;
  tabele.Caption:='';
  for i :=0 to StrToInt(buf)-1 do
    tabele.Caption := tabele.Caption + tcpclient1.receiveln + ', ';
  end;
button_polacz.Enabled:=false;
end;

procedure TForm1.TcpClient1Disconnect(Sender: TObject);
begin
odebrano.caption:='';
wyslano.caption:='';
Polacz1.Caption:='Pracuj w trybie on-line';
StatusBar1.Panels[0].Text:='off-line';
with ustawienia do
  begin
  wersja.Caption:='';
  uptime.Caption:='';
  echo.Caption:='';
  tabele.Caption:='';
  end;
button_polacz.Enabled:=true;
end;

function TForm1.inttobytes(i :integer) :string;
begin
if (i>0) and ((i / 1024)>1) then
  begin
  if (i / (1024*1024))>1 then
    Result := floattostr(roundto(i/(1024*1024), -2))+'Mb'
    else
    Result := floattostr(roundto(i/1024, -2))+'kb';
  end
else
  Result := inttostr(i)+'b';
end;

procedure TForm1.TcpClient1Receive(Sender: TObject; Buf: PAnsiChar;
  var DataLen: Integer);
begin
odebrano.caption :='Odebrano '+inttobytes(tcpclient1.BytesReceived);
end;

procedure TForm1.TcpClient1Send(Sender: TObject; Buf: PAnsiChar;
  var DataLen: Integer);
begin
wyslano.caption:='Wyslano '+inttobytes(tcpclient1.BytesSent);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
if tcpclient1.Connected then tcpclient1.Disconnect;
end;

procedure TForm1.Odswierz1Click(Sender: TObject);
begin
zaladuj_wiezniowie(SQL_WSZYSCY_WIEZNIOWIE);
aktualizuj_nazwy_wiezien;
end;

procedure TForm1.gridMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if grid.cells[5, grid.selection.top]=WOLNOSC_ID then
  menu_zwolnij.Enabled:=false
else
  menu_zwolnij.Enabled:=true;
menu_zamknij.Enabled := not menu_zwolnij.Enabled;
button_zwolnij.Enabled := menu_zwolnij.Enabled;
if not grid.PopupMenu.AutoPopup then button_zwolnij.Enabled:=false;
button_resoc.Enabled := grid.PopupMenu.AutoPopup;
button_dane.Enabled := grid.PopupMenu.AutoPopup;
grid.ColWidths[4]:=-1; // tak samo, jak w Form1Create
grid.ColWidths[5]:=-1;
end;

procedure TForm1.menu_zamknij_defaultClick(Sender: TObject);
var i :integer;
    buf :string;
begin
i:=0;
while (i<TMenuItem(sender).MenuIndex) do
  begin
  inc(i); menu_zakladow.next;
  end;
buf :=menu_zakladow.current[1];
showmessage('Napewno wsadzic go do wiezienia? '); // AREYOUSURE ERROR
while i>0 do
  begin
  dec(i); menu_zakladow.prev;
  end;
with grid do
  zmienzaklad(cells[4, Selection.Top], buf);
odswierz1click(sender);
end;

procedure TForm1.kontaktnowyClick(Sender: TObject);
var tmp :Twiezien;
begin
tmp.plec:=0;
tmp.kolor_oczu:=0;
tmp.kolor_skory:=0;
tmp.karnacja:=0;
if wiezien_form_show(tmp, 'Nowy kontakt') then
  wiezien(tmp, QINSERT);
end;

procedure TForm1.wiezien(var w :Twiezien; typ: TQueryOperationType);
var query :TMyQuery;
begin
query := TMyQuery.Create;
query.operation := typ;
query.table:='wiezniowie';
query.field_add('imie', w.imie);              // UWAGA! kolejnosc wystepowania
query.field_add('nazwisko', w.nazwisko);      // field_add ma znaczenie dla
query.field_add('plec', inttostr(w.plec));    // zapytania SELECT, jesli tu
query.field_add('pesel', w.pesel);            // zmieniasz kolejnosc, zmien tez
query.field_add('imiematki', w.imie_matki);   // cyfry, kilka linii nizej...
query.field_add('cechyszczegolne', w.cechy_szczegolne);
query.field_add('koloroczu', inttostr(w.kolor_oczu));
query.field_add('kolorskory', inttostr(w.kolor_skory));
query.field_add('karnacja', inttostr(w.karnacja));
if w.id='' then query.field_add('id', inttostr(random(MaxInt)))
  else query.field_add('id', w.id);
if w.stan='' then query.field_add('stan', WOLNOSC_ID)
  else query.field_add('stan', w.stan);
if typ in [QSELECT, QUPDATE, QDELETE] then
  query.condition_add('id', w.id);
if typ<>QSELECT then
  sendquery(query.sql)
else
  if select(query.sql, 1)=1 then
    begin
    query.sql := tcpclient1.Receiveln; // moza tez uzyc fetchrecord, ale Result TMyList mniej wygodny
    w.imie:= query.fields[0].value;             // indeksy tablicy fields, zgodnie
    w.nazwisko:= query.fields[1].value;         // z kolejnoscia field_add w query
    w.plec:= strtoint(query.fields[2].value);
    w.pesel:= query.fields[3].value;
    w.imie_matki:= query.fields[4].value;
    w.cechy_szczegolne:= query.fields[5].value;
    w.kolor_oczu:= strtoint(query.fields[6].value);
    w.kolor_skory:= strtoint(query.fields[7].value);
    w.karnacja:= strtoint(query.fields[8].value);
    w.id:= query.fields[9].value;
    w.stan:= query.fields[10].value;
    end;
end;

procedure TForm1.zmienzaklad(id :string; nowystan :string);
begin
sendquery('UPDATE "wiezniowie" SET stan="'+nowystan+'" WHERE id="'+id+'"');
sendquery('INSERT "historia" SET id="'+id+'", idzakl="'+nowystan+'", data="'+datetimetostr(now)+'"');
end;

procedure TForm1.Edytuj1Click(Sender: TObject);
var tmp :Twiezien;
begin
tmp.id:= grid.Cells[4, (grid.Selection.Top)];
wiezien(tmp, QSELECT);
if wiezien_form_show(tmp, 'Edytuj kontakt') then
  wiezien(tmp, QUPDATE);
Odswierz1Click(sender);
end;

function TForm1.wiezien_form_show(var w :Twiezien; caption :string) :boolean;
begin
kontakt.Caption := caption;
with kontakt do
  begin
  imie.Text:=w.imie;
  nazwisko.Text:=w.nazwisko;
  plec.ItemIndex:=w.plec;
  pesel.Text:=w.pesel;
  imie_matki.Text:=w.imie_matki;
  cechy_szczegolne.Text:=w.cechy_szczegolne;
  kolor_oczu.ItemIndex:=w.kolor_oczu;
  kolor_skory.ItemIndex:=w.kolor_skory;
  karnacja.ItemIndex:=w.karnacja;
  ShowModal;
  w.imie := imie.Text;
  w.nazwisko := nazwisko.Text;
  w.plec := plec.ItemIndex;
  w.pesel := pesel.Text;
  w.imie_matki := imie_matki.Text;
  w.cechy_szczegolne := cechy_szczegolne.Text;
  w.kolor_oczu := kolor_oczu.ItemIndex;
  w.kolor_skory := kolor_skory.ItemIndex;
  w.karnacja := karnacja.ItemIndex;
  Result := hide_ok;
  end;
end;

procedure TForm1.Usun1Click(Sender: TObject);
var tmp :Twiezien;
begin
showmessage('Usunac go z bazy?');
tmp.id:= grid.Cells[4, (grid.Selection.Top)];
wiezien(tmp, QDELETE);
sendquery('DELETE FROM "historia" WHERE id="'+tmp.id+'"');
Odswierz1Click(sender);
end;

procedure TForm1.gridMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if (grid.selection.top in [1..grid.RowCount-1]) and (grid.Cells[4, grid.selection.top]<>'') then
  grid.PopupMenu.AutoPopup := true
else grid.PopupMenu.AutoPopup :=false;
end;

procedure TForm1.Odwrotnie1Click(Sender: TObject);
begin
odwrotnie1.Checked := not odwrotnie1.Checked;
odswierz1click(sender);
end;

procedure TForm1.Wgnazwiska1Click(Sender: TObject);
begin
orderby:='nazwisko';
odswierz1click(sender);
TMenuItem(sender).Checked:=true;
end;

procedure TForm1.Wgimienia1Click(Sender: TObject);
begin
orderby:='imie';
odswierz1click(sender);
TMenuItem(sender).Checked:=true;
end;

procedure TForm1.Wgpesel1Click(Sender: TObject);
begin
orderby:='pesel';
odswierz1click(sender);
TMenuItem(sender).Checked:=true;
end;

procedure TForm1.Wgstanu1Click(Sender: TObject);
begin
orderby:='stan';
odswierz1click(sender);
TMenuItem(sender).Checked:=true;
end;

procedure TForm1.Szukaj1Click(Sender: TObject);
begin
znajdz.mode:=0;
znajdz.show;
end;

procedure TForm1.Filtruj1Click(Sender: TObject);
begin
if filtruj1.Checked then
  begin
  filtruj1.Checked := false;
  filtr:='';
  end
else
  begin
  znajdz.mode:=1;
  znajdz.ShowModal;
  Odswierz1Click(sender);
  filtruj1.Checked:=true;
  end;
end;

end.
